" version 0.61
" to do : a lot of things
" require python support compiled in
" require expression evaluation support compiled in

" from 0.60b added an indicator in the statusline when sending

command! ZopeCOMMANDS :call ZopeCOMMANDS()

py import vim, time
py import os, re, httplib, urllib, os, string, base64, urlparse

se laststatus=2
se sessionoptions+=globals

let g:User=""     "can be stored in a session, :mksession <sessfile>
let g:password=""
let g:cookies=""
let g:Url=""      "can be stored in a session, :mksession <sessfile>


function! ZopeCOMMANDS()
	set statusline=%<%f%h%m\ URL=%{g:Url}%r%=%l,%c%V\ %P
	let res=0
	echohl WildMenu | echo "\nUser:".g:User."  URL:http://".g:Url | echohl None
	while res!=1
		let res=confirm("What to do? ", "&cancel\n&user\n&passwd\nu&rl\n&get\n&send\nc&ookies", 1) 
		if res==1
			return
		elseif res==2
			echo "Current:" g:User
			let tmp=input("User? ")
			if tmp!=""
	  			let g:User=tmp
    		endif
		elseif res==3
			if v:version<600
			  let g:password=input("Password (alert! people can see)?")
			else
			  let g:password=inputsecret("Password? ")
			endif
		elseif res==4
			echo "Current:" g:Url
			let tmp=input("URL? ")
			if tmp!=""
	  			let g:Url=tmp
    		endif
			let g:Url=substitute(g:Url, "^http://", "", "")
		elseif res==5
			call ZopeGET()
		elseif res==6
			call ZopeSEND()
		elseif res==7
			call ZopeCOOKIES()
		endif
		echohl WildMenu | echo "\nUser:".g:User."  URL:http://".g:Url | echohl None
	endwhile
endfunction


function! ZopeCOOKIES()
	"set your cookies plain text file
	py cookieFile=open(os.environ['HOME']+'/.galeon/mozilla/galeon/cookies.txt')
	py cookies=cookieFile.readlines()
	py vim.command('let flag=%d' % len(cookies))
	while flag>0
		py cookies[0]=string.replace(cookies[0],'"','\\x22')
		py vim.command('let line="%s"' % cookies[0])
		py line=cookies[0]
		py del cookies[0]
		py vim.command('let flag=%d' % len(cookies))
        "what cookies?
		if line !~ ".bizy" && line !~ ".open4"
			continue
		elseif line !~ "__ac"
			continue
		endif
		py line=re.split('\s+', line)
		py line=string.join((line[0], line[5]+'='+line[6]+';'))
		py line=string.replace(line,'"','\\x22"')
		py vim.command('let line="%s"' % line)
		echohl StatusLine | echo line | echohl None
	endwhile
	py cookieFile.close()
	echo "Current: " g:cookies
	let tmp=input("Cookies? ")
	if tmp!=""
	  let g:cookies=tmp
    endif
endf


function! ZopeSEND()
	let res=confirm("Save to http://".g:User.":"."xxx@".g:Url." ?", "&yes\n&no\n&commands", 2) 
	if res==1
		py data=string.join(vim.current.buffer,'\n')
		py auth=base64.encodestring(vim.eval('g:User')+':'+vim.eval('g:password'))
		py params=urllib.urlencode({'file':data})
		py h=httplib.HTTP(string.split(vim.eval('g:Url'),'/')[0])
		py if string.find(data, "## Script (Python)")==-1: h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1]+'/manage_upload')
		py if string.find(data, "## Script (Python)")!=-1: h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1]+'/ZPythonScriptHTML_upload')
		py h.putheader('Content-type', 'application/x-www-form-urlencoded')
		py h.putheader('Content-length', '%d' % len(params))
		py h.putheader('Accept', 'text/plain')
		py h.putheader('Host', string.split(vim.eval('g:Url'),'/')[0])
		py h.putheader('Authorization', 'Basic '+auth[:-1])
		py h.putheader('Cookie', vim.eval('g:cookies'))
		py h.endheaders()
		py h.send(params)
		py (reply, msg, hdrs)=h.getreply()
		py print reply
		py print msg
		py print hdrs
		
		py vim.command('let err=%d' % reply)
		if err!=200
			echohl ErrorMsg | echo "Error!" | echohl None
		else
			py vim.command('let g:stat="%s"' % time.asctime(time.localtime(time.time())))
			set statusline=%<%f%h%m\ URL=%{g:Url}\ SENT=%{g:stat}%r%=%l,%c%V\ %P
			echohl Title | echo "Sent!" | echohl None
		endif
	elseif res==2
		echohl ErrorMsg | echo "Aborted!" | echohl None
	elseif res==3
		call ZopeCOMMANDS()
	endif
endf


function! ZopeGET()
	let res=confirm("Get http://".g:User.":xxx@".g:Url."/document_src ?", "&yes\n&wo doc src\n&no\n&commands", 3)
	if res==1 || res==2
		py auth=base64.encodestring(vim.eval('g:User')+':'+vim.eval('g:password'))
		py h=httplib.HTTP(string.split(vim.eval('g:Url'),'/')[0])
		if res==1
			py h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1]+'/document_src')
		else
			py h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1])
		endif
		py h.putheader('Content-type', 'application/x-www-form-urlencoded')
		py h.putheader('Content-length', '%d' % 0)
		py h.putheader('Accept', 'text/plain')
		py h.putheader('Host', string.split(vim.eval('g:Url'),'/')[0])
		py h.putheader('Authorization', 'Basic '+auth[:-1])
		py h.putheader('Cookie', vim.eval('g:cookies'))
		py h.endheaders()
		py h.send('')
		py (reply, msg, hdrs)=h.getreply()
		py print reply
		py print msg
		py print hdrs

		py vim.command('let err=%d' % reply)
		if err!=200
			echohl ErrorMsg | echo "Error!" | echohl None
		else
			py lines=h.getfile().readlines()
			py if len(lines)>0 and lines[-1][-1]!='\n': lines[-1]=lines[-1]+'\n'
			py vim.current.buffer.append(map(lambda x: x[:-1], lines))
			set statusline=%<%f%h%m\ URL=%{g:Url}%r%=%l,%c%V\ %P
			echohl Title | echo "Received!" | echohl None
		endif
	elseif res==3
		echohl ErrorMsg | echo "Aborted!" | echohl None
	elseif res==4
		call ZopeCOMMANDS()
	endif
endf


" vim:ts=4:sw=4
